Plugin.extend({
    _type: 'uth',
    _isContainer: false,
    _render: true,

    /**
     * @author Swati Singh
     **/
    initPlugin: function(data) {
        var instance = this;
        var dims = this.relativeDims();
        var controller = this._stage.getController("item");
        if (controller) {
            this._controller = controller;
        }
        this._self = new createjs.Container();
        this._self.x = dims.x;
        this._self.y = dims.y;
        this._self.origX = dims.x;
        this._self.origY = dims.y;
        this._self.width = dims.w;
        this._self.height = dims.h;
        this._render = true;

        function shuffle(a) {
            for (let i = a.length; i; i--) {
                let j = Math.floor(Math.random() * i);
                [a[i - 1], a[j]] = [a[j], a[i - 1]];
            }
        }
        /*UTH Plugin starts*/
        var totalwidth = data.w;
        var totalheight = data.h;
        var x = data.x;
        var y = data.y;

        /* Only familiar objets are supported in this version */
        var familiarObjectImages = ['image1', 'image2', 'image3', 'image4', 'image5'];
        var imageSource = [];
        if (this._controller.getModelValue("imageType") == "familiarObjects") {
            imageSource = familiarObjectImages;
        }

        // Below commented code is for next version
        /*else if (this._controller.getModelValue("imageType") == "Geometric Shapes") {
            imageSource = source2;
        } else if (this._controller.getModelValue("imageType") == "Number Representation") {
            imageSource = source3;
        }*/


        /**
         * Following condition checkes wether the image and count of image is already set for that question or not.
         * If not already set it randomly picks one image from the given sets of images and generates a random no from the countdigit given.
         * Generate options and set correct answer
         **/
        var input, options;
        if (!this._controller.getModelValue("isNumberSet")) {
            this._controller.setModelValue("isNumberSet", true);
            input = this.generateRandomNumber(this._stage.getModelValue(data.inputdata));
            this._controller.setModelValue("imageCount", input);
            options = [];
            options.push(input - 1);
            options.push(input);
            options.push(input + 1);
            shuffle(options);
            imageSource = imageSource[Math.floor(Math.random() * imageSource.length)];
            this._controller.setModelValue("imageSource", imageSource);
            var optionData = this._controller.getModelValue("options");
            var optionsDetail = [];
            for (var i = 0; i < options.length; i++) {
                var optionObj = optionData[i];
                if (optionObj != undefined) {
                    if (optionObj.answer) {
                        delete optionObj.answer;
                    }
                    if (options[i] == input) {
                        optionObj.answer = true;
                    }
                    optionObj.value.text = String(options[i]);
                    optionsDetail.push(optionObj);
                }

            }
            this._controller.setModelValue(("options"), optionsDetail);

        }
        drawimages(x, y);

        /**
         * Invoke the placeholder plugin to draw images
         * model value image source is the selected iamge to show in question
         * model value image count is the no of time image needs to be shown
         **/
        function drawimages(x, y) {
            var imagescontainer;
            var initialxvalueunit = x;
            var d = {};
            d.x = data.x;
            d.y = data.y;
            d.w = data.w;
            d.h = data.h;
            d.type = 'gridLayout';
            d.asset = instance._controller.getModelValue("imageSource");
            d.count = instance._controller.getModelValue("imageCount");;
            PluginManager.invoke('placeholder', d, instance, instance._stage, instance._theme);

        }
    },
    /**
     * @member of counting image
     * Take number as an input.
     * Right now only support 1 and 2 as input
     * Returns randomly generated number as per the input digit 
     */
    generateRandomNumber: function(num) {
        var min = 0;
        var max = 0;
        switch (num) {
            case '1':
                min = 1;
                max = 9;
                break;
            case '2':
                min = 10;
                max = 99;
                break;
        }
        var result = _.random(min, max);
        return result;
    }

});
